function PlacesPreviewTreeView(view,tree) {
  //dump("new places tree view\n");
  this._treeType = tree;
  this._view = view;
  for (var p in view){
    try{
      if (!(p in this)){
        var type = (typeof view[p]);
        if (type == "function"){
          this[p] = function(){
            var name = arguments.callee.name;
            return this._view[name].apply(this._view,arguments);
          }
          this[p].name = p;
        }
        else{
          var funcGet = function() {
            var name = arguments.callee.name;
            return view[name];
          }
          funcGet.name = p;
          var funcSet = function(x) {
            var name = arguments.callee.name;
            view[name] = x;
          }
          funcSet.name = p;
          this.__defineGetter__(p, funcGet);
          this.__defineSetter__(p, funcSet);
        }
      }
    }catch(e){
      dump("PlacesPreviewTreeView error: "+e+"\n");
    }
  }
}
PlacesPreviewTreeView.prototype = {
  itemInserted: function(parent, item, newIndex) {
    dump("tree: "+this._treeType+" - "+"item inserted: "+item.title+"\n");
    this.lastItem = item.itemId;
    this._view.itemInserted.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay();
  },
  itemRemoved: function(parent, item, oldIndex) {
    dump("tree: "+this._treeType+" - "+"item removed: "+item.title+"\n");
    this.lastItem = item.itemId;
    this._view.itemRemoved.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay();
  },
  itemChanged: function(item) {
    dump("tree: "+this._treeType+" - "+"item changed: "+item.title+"\n");
    this._view.itemChanged.apply(this._view,arguments);
  },
  itemReplaced: function(parent, oldItem, newItem, index) {
    dump("tree: "+this._treeType+" - "+"itemReplaced: " + newItem.uri + "\n");
    this.lastItem = item.itemId;
    this._view.itemReplaced.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay();
  },
  itemMoved: function(item, oldParent, oldIndex, newParent, newIndex) {
    dump("tree: "+this._treeType+" - "+"item moved\n");
    this.lastItem = item.itemId;
    this._view.itemMoved.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay();
  },
  containerOpened: function(item) {
    dump("tree: "+this._treeType+" - "+"container opened: "+item.title+"\n");
    this._view.containerOpened.apply(this._view,arguments);
    setTimeout(function(){
      //dump("container opened\n");
      if (PlacesPreviewUtils.utils)
        PlacesPreviewUtils.utils.refreshDisplay(true);
    },0);
  },
  containerClosed: function(item) {
    dump("tree: "+this._treeType+" - "+"container closed: "+item.title+"\n");
    this._view.containerClosed.apply(this._view,arguments);
  },
  invalidateContainer: function(item) {
    dump("tree: "+this._treeType+" - "+"invalidateContainer(): "+item.title+"\n");
    this._view.invalidateContainer.apply(this._view,arguments);
  },
  invalidateAll: function() {
    dump("tree: "+this._treeType+" - "+"invalidateAll\n");
    this._view.invalidateAll.apply(this._view,arguments);
    setTimeout(function(){
      dump("invalidate all\n");
      PlacesPreviewUtils.utils.refreshDisplay(true);
    },0);
  },
  get sortingMode(){
    return this._result.sortingMode;
  },
  sortingChanged: function(sortingMode) {
    //dump("tree: "+this._treeType+" - "+"sorting changed: "+sortingMode+"\n");
    this._view.sortingChanged.apply(this._view,arguments);
  }
};
